//Scanning a toothed disk with optical sensors
//
//
//The circuit:
//LCD RS pin to digital pin 12
//LCD Enable pin to digital pin 11
//LCD D4 pin to digital pin 5
//LCD D5 pin to digital pin 4
//LCD D6 pin to digital pin 3
//LCD D7 pin to digital pin 2
//LCD R/W pin to ground
//10K potentiometer:
//ends to +5V and ground
//wiper to LCD VO pin (pin 3)
//
//Optical sensors to pin 0 and 1
//
//Source & info at: www.HomoFaciens.de/technics-computer-arduino-uno_en_navion.htm


// include the library code:
#include <LiquidCrystal.h>

int sensor_00 = 0;
int sensor_01 = 0;
int readValue = 0;
int step = 0;

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

void setup() {
  // set up the LCD's number of columns and rows: 
  lcd.begin(16, 2);
  // Print a message to the LCD.
  lcd.print("Optical sensor");
}

void loop() {
  
  sensor_01 = digitalRead(0);
  sensor_00 = digitalRead(1);
  
  if(sensor_00 == 0 && sensor_01 == 0){
    if(step == 1){
      readValue--;
    }
    if(step == 3){
      readValue++;
    }
    step = 0;
  }

  if(sensor_00 == 0 && sensor_01 == 1){
    if(step == 2){
      readValue--;
    }
    if(step == 0){
      readValue++;
    }
    step = 1;
  }

  if(sensor_00 == 1 && sensor_01 == 1){
    if(step == 3){
      readValue--;
    }
    if(step == 1){
      readValue++;
    }
    step = 2;
  }

  if(sensor_00 == 1 && sensor_01 == 0){
    if(step == 0){
      readValue--;
    }
    if(step == 2){
      readValue++;
    }
    step = 3;
  }
  
  
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  lcd.setCursor(0, 1);
  // print the number of seconds since reset:
  lcd.print("Count = ");
  lcd.print(readValue);
  lcd.print("   ");
}

